
# name: mainserver
# version: 0.2.0.0
# config: mainserver.conf
# description:
# requires: this_module_needs_to_be_converted

namespace eval mainserver {

  global owner

  set NamespaceParent [namespace parent]
  set NamespaceCurrent [namespace current]

  set Config(checkdelay) [expr 30 + [rand 10]]
  set Config(retrydelay) [expr 300 + [rand 50]]
  set Config(notify) [replaceExpr [replaceExpr $owner "," " "] "  " " "]
  set Config(channels) [channels]
  set Config(minbots) 2
  if {![info exists Loaded]} then {set Loaded 0}

  proc CheckServer {retry} {
    global server servers default-port
    variable Config
    variable NamespaceCurrent

    set MainServer [string trimleft [string trimright [lindex $servers 0]]]
    if {[string compare $server $MainServer]} then {
      wpLog o * $NamespaceCurrent "I'm not on $MainServer - checking to see if I can jump..."
      foreach chan $Config(channels) {
        set found($chan) 0
        foreach bot [bots] {
          if {$found($chan) >= $Config(minbots)} then {
            break
          }
          set nick [hand2nick $bot $chan]
          if {(![string compare "*" $nick]) || \
              (![matchattr $bot b]) || \
              (![matchattr $bot o|o $chan]) || \
              (![isop $nick $chan]) || \
              ([onchansplit $nick $chan])} then {
            continue
          } else {
            incr found($chan)
          }
        }

        if {$found($chan) < $Config(minbots)} then {
          if {$retry} then {
            wpLog o * $NamespaceCurrent "Error: Can't jump servers (retry) -- too few op'd bots on $chan, need: $Config(minbots), found: $found($chan)"
            foreach i $Config(notify) {
              catch {
                sendnote [getBotName] $i "${NamespaceCurrent}: Error: Failed to connect to server $MainServer."
              }
            }
            timer $Config(checkdelay) "${NamespaceCurrent}::CheckServer 0"
          } else {
            wpLog o * $NamespaceCurrent "Error: Can't jump servers -- too few op'd bots on $chan, need: $Config(minbots), found: $found($chan)"
            utimer $Config(retrydelay) "${NamespaceCurrent}::CheckServer 1"
          }
          return 0
        }
      }
      regsub -all -- : $MainServer " " NewServer
      eval jump $NewServer
    }
    timer $Config(checkdelay) "${NamespaceCurrent}::CheckServer 0"
    return 1
  }

  if {!$Loaded} then {
    timer $Config(checkdelay) "${NamespaceCurrent}::CheckServer 0"
    set Loaded 1
  }

} ;# namespace mainserver
